=== debian/changelog ===
libsqlite-jdbc-java (3.27.2.1+ds-0kali1) kali-dev; urgency=medium

  * Initial release

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 23 May 2019 14:49:34 +0200
