=== debian/control ===
Source: libsqlite-jdbc-java
Section: java
Priority: optional
Maintainer: Sophie Brun <sophie@offensive-security.com>
Build-Depends: debhelper-compat (= 12), default-jdk, libsqlite3-dev,
 maven-debian-helper, libmaven-jar-plugin-java, javahelper
Build-Depends-indep: libmaven-bundle-plugin-java, junit
Standards-Version: 4.3.0
Homepage: https://github.com/xerial/sqlite-jdbc
Vcs-Browser: https://gitlab.com/kalilinux/packages/libsqlite-jdbc-java
Vcs-Git: https://gitlab.com/kalilinux/packages/libsqlite-jdbc-java.git

Package: libsqlite-jdbc-java
Architecture: all
Depends: ${misc:Depends}, libsqlite-jdbc-jni, junit
Description: SQLite JDBC Driver in Java
 This package contains a library for accessing and creating SQLite database
 files in Java.
 .
 This package contains the bindings.

Package: libsqlite-jdbc-jni
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: SQLite JDBC Driver
 This package contains a library for accessing and creating SQLite database
 files in Java.
 .
 This package contains the architecture specific Java native interface part.
