=== debian/watch ===
version=4
opts="dversionmangle=s/\+ds\d*$//,repacksuffix=+ds,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libsqlite-jdbc-java-$1.tar.gz%" \
   https://github.com/xerial/sqlite-jdbc/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
